﻿using System;
using System.Collections;
using System.Data.Linq;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Linq;
using Telerik.Web.UI;

namespace RadGridLinq
{
    public partial class ManualCRUD : System.Web.UI.Page
    {
        private LINQDataClassDataContext _dataContext;

        protected LINQDataClassDataContext DataContext
        {
            get
            {
                if (_dataContext == null)
                {
                    _dataContext = new LINQDataClassDataContext();
                }
                return _dataContext;
            }
        }

        public override void Dispose()
        {
            if (_dataContext != null)
            {
                _dataContext.Dispose();
            }
            base.Dispose();
        }

        protected void RadGrid1_NeedDataSource(object source, GridNeedDataSourceEventArgs e)
        {
            RadGrid1.DataSource = DataContext.Customers;
        }

        protected void RadGrid1_UpdateCommand(object source, GridCommandEventArgs e)
        {
            var editableItem = ((GridEditableItem)e.Item);

            //extract CustomerID of GridItem being updated
            var customerID = (string)editableItem.GetDataKeyValue("CustomerID");

            //retrive entity form the database associated with the above CustomerID
            var customer = DataContext.Customers.Where(n => n.CustomerID == customerID).FirstOrDefault();
            if (customer != null)
            {
                //update entity's information with what was entered in the RadGrid
                editableItem.UpdateValues(customer);

                try
                {
                    //submit above changes to the database
                    DataContext.SubmitChanges();
                }
                catch (Exception ex)
                {
                    errorLiteral.Text = ex.ToString();
                }
            }
        }

        protected void RadGrid1_InsertCommand(object source, GridCommandEventArgs e)
        {
            var editableItem = ((GridEditableItem)e.Item);
            
            //create new Cusomter entity
            Customer customer = new Customer();

            //extract values from the item we are inserting
            Hashtable values = new Hashtable();
            editableItem.ExtractValues(values);

            //populate entity's relevant properties
            customer.CompanyName = (string)values["CompanyName"];
            customer.ContactName = (string)values["ContactName"];
            customer.City = (string)values["City"];
            customer.Bool = (bool?)values["Bool"];

            //queue entity for insertion in the database on next submit
            DataContext.Customers.InsertOnSubmit(customer);

            try
            {
                //submit above insert to database
                DataContext.SubmitChanges();
            }
            catch (Exception ex)
            {
                errorLiteral.Text = ex.ToString();
            }
        }

        protected void RadGrid1_DeleteCommand(object source, GridCommandEventArgs e)
        {
            var customerID = (string)((GridDataItem)e.Item).GetDataKeyValue("CustomerID");

            //retrieve entity to be deleted from the database
            var customer = DataContext.Customers.Where(n => n.CustomerID == customerID).FirstOrDefault();
            if (customer != null)
            {
                //queue entity for deletion from the database on next submit
                DataContext.Customers.DeleteOnSubmit(customer);
                try
                {
                    //submit above delete to database
                    DataContext.SubmitChanges();
                }
                catch (Exception ex)
                {
                    errorLiteral.Text = ex.ToString();
                }
            }
        }
    }
}
